ThirdPartyFunctions 13.9 KB
Newer Older
Henry's avatar
Henry committed
1 2 3 4
#---------------------------------*- sh -*-------------------------------------
# =========                 |
# \\      /  F ield         | OpenFOAM: The Open Source CFD Toolbox
#  \\    /   O peration     |
5
#   \\  /    A nd           | Copyright (C) 2011-2016 OpenFOAM Foundation
6
#    \\/     M anipulation  | Copyright (C) 2016-2018 OpenCFD Ltd.
Henry's avatar
Henry committed
7 8
#------------------------------------------------------------------------------
# License
Mark Olesen's avatar
Mark Olesen committed
9 10
#     This file is part of OpenFOAM, licensed under GNU General Public License
#     <http://www.gnu.org/licenses/>.
Henry's avatar
Henry committed
11 12 13 14 15
#
# File
#     etc/tools/ThirdPartyFunctions
#
# Description
16
#     Various functions used in building ThirdParty packages
Henry's avatar
Henry committed
17 18 19 20 21
#
#     Define the standard buildBASE and installBASE for the platform
#     Define WM_NCOMPPROCS always.
#------------------------------------------------------------------------------

22 23
# The normal locations for source, build and installation (prefix-dir)
sourceBASE=$WM_THIRD_PARTY_DIR
Henry's avatar
Henry committed
24 25 26
buildBASE=$WM_THIRD_PARTY_DIR/build/$WM_ARCH$WM_COMPILER
installBASE=$WM_THIRD_PARTY_DIR/platforms/$WM_ARCH$WM_COMPILER

27 28 29
# Dynamic library endings (default is .so)
[ "$(uname -s)" = Darwin ] && SO=dylib || SO=so

30
unset BUILD_SUFFIX
31
#------------------------------------------------------------------------------
32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57
# Export WM compiler settings (and flags) for CMake/configure
# $1 = true: export compiler flags too
exportCompiler()
{
    if test -n "$WM_CC" && command -v "$WM_CC" >/dev/null
    then
        export CC="$WM_CC"
        if [ "$1" = true -a -n "$WM_CFLAGS" ]
        then
            export CFLAGS="$WM_CFLAGS"
        fi
    fi

    if test -n "$WM_CXX" && command -v "$WM_CXX" >/dev/null
    then
        export CXX="$WM_CXX"
        if [ "$1" = true -a -n "$WM_CXXFLAGS" ]
        then
            export CXXFLAGS="$WM_CXXFLAGS"
        fi
    fi
}

# Export WM linker settings for CMake/configure
exportLinker()
{
58 59 60 61
    if [ -n "$WM_LDFLAGS" ]
    then
        export LDFLAGS="$WM_LDFLAGS"
    fi
62 63
}

64 65 66 67 68 69 70
# Force use of gcc/g++
useGcc()
{
    export CC=gcc    # Use gcc/g++
    export CXX=g++
}

71 72 73 74 75 76 77 78 79 80 81 82 83
# Scan arguments for a '-gcc' option, forcing gcc/g++ when found
useGccFlag()
{
    for i
    do
        if [ "$i" = "-gcc" ]
        then
            useGcc
            break
        fi
    done
}

84 85 86
# Return <mpicc> by default or <mpiicc> if possible for INTELMPI.
# Cray doesn't have <mpicc>, but its <cc> manages mpi paths directly.
# NOTE: could further refine based on $CC or $WM_CC, but not yet needed
87 88
whichMpicc()
{
89
    local mpicc=$(command -v mpicc)
90 91
    case "$WM_MPLIB" in
    (INTELMPI)
92 93 94 95
        mpicc=$(command -v mpiicc)  # Intel <mpiicc> available?
        ;;
    (CRAY-MPI*)
        : ${mpicc:=cc}              # Cray <cc> if there is no <mpicc>
96 97
        ;;
    esac
98
    echo "${mpicc:-mpicc}"
99 100
}

101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123
# The presence of wmkdep etc required for building with wmake
requireWMakeToolchain()
{
    local dir="${WM_DIR:-$WM_PROJECT_DIR/wmake}"
    local src="$dir/src"
    local bin="$dir/platforms/$WM_ARCH$WM_COMPILER/wmkdep"

    test -x $bin || {
        echo "Warning: the 'wmkdep' binary is missing - attempting to build it"
        ( cd $src && make -s )
    }

    test -x $bin || {
        exec 1>&2
        echo
        echo "Error: cannot use wmake build for '${0##*/}"
        echo "    The 'wmkdep' binary is missing"
        echo "    Please run the top-level OpenFOAM Allwmake first"
        echo
        exit 1
    }
}

124 125 126
#------------------------------------------------------------------------------
# Some functions as per OpenFOAM etc/config.sh/functions

127
unset -f _foamAddLib _foamAddLibAuto _foamAddMan _foamAddPath # Get settings only
128
unset -f _foamClean _foamConfig
129 130 131 132 133 134 135 136 137 138 139 140 141

if [ -x "$WM_PROJECT_DIR/bin/foamCleanPath" ]
then
    # Cleaning environment variables
    _foamClean()
    {
         local var=$1
         shift
         eval $($WM_PROJECT_DIR/bin/foamCleanPath -sh-env=$var "$@")
    }
else
    _foamClean() { echo "No foamCleanPath" 1>&2; }
fi
142

143 144
# Source an etc/config.sh file
_foamConfig() { eval "$($WM_PROJECT_DIR/bin/foamEtcFile -sh -config $@)"; }
145

146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163
#------------------------------------------------------------------------------

#
# Set a suffix for the build
# - eg, for -mpi, or -mesa etc
#
setBuildSuffix()
{
    BUILD_SUFFIX="${1##-}"
    if [ -n "$BUILD_SUFFIX" ]
    then
        BUILD_SUFFIX="-${BUILD_SUFFIX}"
    else
        unset BUILD_SUFFIX
    fi
}


Henry's avatar
Henry committed
164
#
165
# Mostly building without wmake
Henry's avatar
Henry committed
166
# - disable wmakeScheduler variables
167
# - use max number of cores for building
Henry's avatar
Henry committed
168 169
#
unset WM_HOSTS WM_SCHEDULER
170 171 172 173 174

WM_NCOMPPROCS=$(egrep -c "^processor" /proc/cpuinfo 2>/dev/null) || \
WM_NCOMPPROCS=$(getconf _NPROCESSORS_ONLN 2>/dev/null) || \
WM_NCOMPPROCS=1
: ${WM_NCOMPPROCS:=1}
175
export WM_NCOMPPROCS
Henry's avatar
Henry committed
176 177 178


#
179 180
# If WM_CONTINUE_ON_ERROR not set activate the shell option "stop on error"
#
181
if [ -z "$WM_CONTINUE_ON_ERROR" ]
182 183 184 185 186
then
    set -e
fi


187 188 189 190 191 192 193 194 195 196 197
# Report error and exit
die()
{
    exec 1>&2
    echo
    echo "Error: see '${0##*/} -help' for usage"
    while [ "$#" -ge 1 ]; do echo "    $1"; shift; done
    echo
    exit 1
}

198 199 200 201 202 203 204 205 206 207 208 209 210
# Test if it matches "*-none"
_foamIsNone()
{
    test "${1##*-}" = none
}

# Test if it matches "*-system"
_foamIsSystem()
{
    test "${1##*-}" = system
}


211
#
212 213 214 215
# Try to locate cmake according to the CMAKE_PATH.
#
# On success: return the resolved value as output.
# On failure: just report what is found in the path.
216
#
217
unset CMAKE_PATH # clear when first loaded
218 219
findCMake()
{
220
    local candidate foundExe
221 222 223

    if [ -n "$CMAKE_PATH" ]
    then
224
        # Check as directory
225 226 227 228 229 230 231 232 233 234 235 236 237 238 239
        if [ -d "$CMAKE_PATH" ]
        then
            for candidate in \
                $CMAKE_PATH/cmake \
                $CMAKE_PATH/bin/cmake \
            ;
            do
                if [ -f "$candidate" -a -x "$candidate" ]
                then
                    foundExe=$candidate
                    break
                fi
            done
        fi

240
        # Check as file, include ThirdParty installation in the search
241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263
        if [ -z "$foundExe" ]
        then
            for candidate in \
                $CMAKE_PATH \
                $installBASE/$CMAKE_PATH/bin/cmake \
                $installBASE/cmake-$CMAKE_PATH/bin/cmake \
            ;
            do
                if [ -f "$candidate" -a -x "$candidate" ]
                then
                    foundExe=$candidate
                    break
                fi
            done
        fi

        if [ -n "$foundExe" ]
        then
            # Use absolute path
            if [ "${foundExe#/}" = "$foundExe" ]
            then
                foundExe="$(cd ${foundExe%/cmake} 2>/dev/null && pwd)/cmake"
            fi
264
            echo "Using cmake=$foundExe" 1>&2
265
            echo $foundExe
266 267 268 269 270 271 272 273 274 275
            return 0
        else
            cat << NOT_FOUND 1>&2
'cmake' not found under specified CMAKE_PATH
    CMAKE_PATH=$CMAKE_PATH
reverting to using command from path
NOT_FOUND
        fi
    fi

276 277 278 279 280 281 282
    # Default to use the path, try resolving (so we know what we are using).
    for candidate in cmake
    do
        foundExe=$(command -v $candidate 2>/dev/null) && break
    done
    : ${foundExe:=false}

283 284
    echo "Using cmake=$foundExe" 1>&2
    echo $foundExe
285 286 287 288
}


#
289
# Try to locate qmake or qmake-qt5 according to the QMAKE_PATH
290 291 292
#
# On success: return the resolved value as output.
# On failure: just report what is found in the path.
293
#
294
unset QMAKE_PATH # clear when first loaded
295
findQMake()
296
{
297
    local candidate foundExe
298 299 300

    if [ -n "$QMAKE_PATH" ]
    then
301
        # Check as directory
302 303 304 305 306 307 308 309 310 311 312 313 314 315 316
        if [ -d "$QMAKE_PATH" ]
        then
            for candidate in \
                $QMAKE_PATH/qmake \
                $QMAKE_PATH/bin/qmake \
            ;
            do
                if [ -f "$candidate" -a -x "$candidate" ]
                then
                    foundExe=$candidate
                    break
                fi
            done
        fi

317
        # Check as file, include ThirdParty installation in the search
318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340
        if [ -z "$foundExe" ]
        then
            for candidate in \
                $QMAKE_PATH \
                $installBASE/$QMAKE_PATH/bin/qmake \
                $installBASE/qt-$QMAKE_PATH/bin/qmake \
            ;
            do
                if [ -f "$candidate" -a -x "$candidate" ]
                then
                    foundExe=$candidate
                    break
                fi
            done
        fi

        if [ -n "$foundExe" ]
        then
            # Use absolute path
            if [ "${foundExe#/}" = "$foundExe" ]
            then
                foundExe="$(cd ${foundExe%/qmake} 2>/dev/null && pwd)/qmake"
            fi
341
            echo "Using qmake=$foundExe" 1>&2
342
            echo $foundExe
343 344 345 346 347 348 349 350 351 352
            return 0
        else
            cat << NOT_FOUND 1>&2
'qmake' not found under specified QMAKE_PATH
    QMAKE_PATH=$QMAKE_PATH
reverting to using command from path
NOT_FOUND
        fi
    fi

353 354 355 356 357 358 359 360
    # Default to use the path, try resolving (so we know what we are using).
    # Some systems have qmake-qt5 as well as qmake
    for candidate in qmake-qt5 qmake
    do
        foundExe=$(command -v $candidate 2>/dev/null) && break
    done
    : ${foundExe:=false}

361 362
    echo "Using qmake=$foundExe" 1>&2
    echo $foundExe
363 364 365
}


366
#
367
# Set a new prefix=... in pkgconfig files
368
#
369
pkgconfigNewPrefix()
370
{
371
    local dir="${1%%/}"
372

373
    if [ -n "$dir" -a -d "$dir" ]
374
    then
375 376 377 378 379 380 381 382 383 384 385 386 387 388
        # Require absolute path, but use logical (not physical) location
        [ "${dir}" != "${dir#/}" ] || dir=$(cd $dir 2>/dev/null && /bin/pwd -L)
        # Strip sub-level
        case "$dir" in (*/pkgconfig) dir="${dir%/*}";; esac
        # Strip a level
        case "$dir" in (*/lib | */lib64 | */bin) dir="${dir%/*}";; esac
    fi

    # Verify that the prefix path is valid
    # Warning (not an error) - thus no special return code
    [ -n "$dir" -a -d "$dir" ] || {
        echo "Warning: invalid prefix directory: $dir" 1>&2
        return 0
    }
389

390
    echo "Set pkgconfig prefix : $dir"
391

392 393 394 395 396 397
    local nfiles
    for libdir in lib/pkgconfig lib64/pkgconfig
    do
        unset nfiles
        [ -d "$dir/$libdir" ] || continue
        for i in $dir/$libdir/*.pc
398
        do
399
            if [ -f "$i" -a ! -L "$i" ]
400 401
            then
                nfiles="x$nfiles"
402
                sed -i~ -e 's@^\(prefix=\).*$@\1'"$dir@" $i
403 404
            fi
        done
405 406
        echo "    $libdir/*.pc  (edited ${#nfiles})"
    done
407 408 409 410
}


#
411 412 413 414 415
# Adjust pkgconfig information to use '${prefix} where possible instead
# of directory paths.
#
# Adjusts includedir=, libdir=, -I/... and -L/... and
# any *_location= entries (QT)
416 417 418
#
pkgconfigAdjust()
{
419
    local dir="${1%%/}"
420

421
    if [ -n "$dir" -a -d "$dir" ]
422
    then
423 424 425 426 427 428 429
        # Require absolute path, but use logical (not physical) location
        [ "${dir}" != "${dir#/}" ] || dir=$(cd $dir 2>/dev/null && /bin/pwd -L)
        # Strip sub-level
        case "$dir" in (*/pkgconfig) dir="${dir%/*}";; esac
        # Strip a level
        case "$dir" in (*/lib | */lib64 | */bin) dir="${dir%/*}";; esac
    fi
430

431 432 433 434 435 436
    # Verify that the prefix path is valid
    # Warning (not an error) - thus no special return code
    [ -n "$dir" -a -d "$dir" ] || {
        echo "Warning: invalid prefix directory: $dir" 1>&2
        return 0
    }
437

438 439 440 441 442 443 444 445
    echo "Adjust pkgconfig locations : $dir"

    local nfiles
    for libdir in lib/pkgconfig lib64/pkgconfig
    do
        unset nfiles
        [ -d "$dir/$libdir" ] || continue
        for i in $dir/$libdir/*.pc
446
        do
447
            if [ -f "$i" -a ! -L "$i" ]
448 449
            then
                nfiles="x$nfiles"
450
                sed -i~ \
451 452 453 454
                    -e 's@^\(includedir=\)'"$dir/"'@\1${prefix}/@' \
                    -e 's@^\(libdir=\)'"$dir/"'@\1${prefix}/@'     \
                    -e 's@\(_location=\)'"$dir/"'@\1${prefix}/@'   \
                    -e 's@\(-[IL]\)'"$dir/"'@\1${prefix}/@g'       \
455 456 457
                    $i
            fi
        done
458 459
        echo "    $libdir/*.pc  (edited ${#nfiles})"
    done
460 461 462
}


463 464
#
# Download file $1 from url $2 into download/ directory
Henry's avatar
Henry committed
465 466 467 468 469 470 471 472
#
downloadFile()
{
    [ "$#" -eq 2 ] || {
        echo "downloadFile called with incorrect number of arguments $@"
        return 1
    }

473 474
    local file="$1"
    local url="$2"
Henry's avatar
Henry committed
475 476 477 478 479 480 481 482 483 484 485

    if [ ! -e download/$file ]
    then
        mkdir -p download
        echo "downloading $tarFile from $url"
        ( cd download && wget --no-check-certificate $url -O $file )
    fi
}


#
486
# Copy Make/{files,options} from etc/makeFiles/PACKAGE
Henry's avatar
Henry committed
487 488
#
# $1 = PACKAGE
489
# $2 = TARGET DIRECTORY (optional)
Henry's avatar
Henry committed
490 491 492 493 494 495 496
cpMakeFiles()
{
    [ "$#" -eq 1 -o "$#" -eq 2 ] || {
        echo "cpMakeFiles called with incorrect number of arguments $@"
        return 1
    }

497 498
    local pkg=$1
    local dst="${2:-.}"
Henry's avatar
Henry committed
499 500
    echo "cpMakeFiles" $pkg $dst

501
    wmakeFiles=$WM_THIRD_PARTY_DIR/etc/makeFiles/$pkg
Henry's avatar
Henry committed
502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525

    for i in $(cd $wmakeFiles && find . -type f)
    do
        d=${i%/*}   # dirname
        b=${i##*/}   # basename

        mkdir -p $dst/$d/Make 2>/dev/null

        # NOTE the behaviour of '-nt' can cause problems
        #
        # - bash, ksh, /usr/bin/test
        #   True, if file1 exists and file2 does not
        #
        # - dash, zsh (and maybe others)
        #   False, if file1 or file2 does not exist
        #
        if [ ! -e $dst/$d/Make/$b -o $wmakeFiles/$i -nt $dst/$d/Make/$b ]
        then
            cp $wmakeFiles/$i $dst/$d/Make/$b
        fi
    done
}


526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554
#
# Apply source-code patch if possible.
# Patches are taken from etc/patches/PACKAGE
#
# $1 = PACKAGE
# $2 = TARGET DIRECTORY (optional)
applyPatch()
{
    [ "$#" -eq 1 -o "$#" -eq 2 ] || {
        echo "applyPatch called with incorrect number of arguments ($#): $@"
        return 1
    }

    local pkg="$1"
    local dst="${2:-.}"

    local patch="$WM_THIRD_PARTY_DIR/etc/patches/$pkg"
    local sentinel="PATCHED_DURING_OPENFOAM_BUILD"

    if [ -r "$patch" ]
    then
    (
        cd $dst || exit 1
        if [ -f "$sentinel" ]
        then
            echo "patch for $pkg was already applied"
        else
            echo "apply patch for $pkg"
            touch "$sentinel"
555
            patch -b -l -p1 < $patch 2>&1 | tee $sentinel
556 557 558 559 560 561 562
        fi
    )
    else
        echo "no patch found for $pkg"
    fi
}

563

564
#------------------------------------------------------------------------------